/* $Id: Jwv.java,v 1.21 2009/10/13 00:43:41 mit Exp $ */
/* Jwv.java v1.4 (Java Wave Viewer) */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.text.DecimalFormat;

public class Jwv extends Applet
    implements AdjustmentListener, ActionListener, ItemListener, 
    MouseListener, MouseMotionListener 
{
    static final int WAVE = 0;
    static final int FFT_ = 1;
    static final double SMaxVal = Short.MAX_VALUE;
    static final double Sqrt2 = Math.sqrt(2);
    static final String[] sample = 
    {"14","13","12","11","10","9"};  // 16384,8192,4096,2048,1024,512

    boolean TextSW;                  // text sw.
    boolean MoveSW;                  // mouse move sw.
    boolean DragSW;
    boolean WaveSW;
    boolean FftSW;
    boolean FftColor;
    int W;                           // canvas w 370
    int H;                           //  "     h 310
    int H2;                          // wave center
    int FNT;
    int AF;                          // all wave file 
    int Num = 14;                    // for fft
    int SPL = (int)Math.pow(2, Num); // fft sampl
    int SPH = SPL/2;                 // spl/2
    int Splngf = 44100;              // data sampling frq.
    int Cnt;                         // wave max data
    int Wid;                         //  "
    int Psi;                         //  "   position
    int Slc = 0;                     //  "   select
    int BaseLine;                    // memori line   
    int Wby = 8;                     // for -,+ x2
    int firstx, lastx;               // for mouse
    int Smax;                        // Splngf/Wby
    int Wmax;                        // SPL/Wby
    int Vert = 40;                   // scrV
    int Hori = 20;                   // scrH
    int Grap;
    int WaveCnt;
    int FftCnt;
    int AllC;
    double WD;                       // w/wid
    double SD;                       // w/Splngf
    double Whby;
    double Fhby;
    double LPS;
    String Dirnm;
    String Fname;
    String Error;
    String Label;
    int[] dat;
    double[] re;
    double[] im;
    double[] dt;
    double[] Gauss;
    String[] filenm;
    Color bar = new Color(64, 128, 255);
    Color[] Gc;

    DecimalFormat df1, df2;
    Graphics gi;
    Image ig;
    Font Fnt, Fns;
    FontMetrics fm;
    FFT fftN;

    private Button btZin, btZout; // zoom in,out
    private Button btP, btM;  // >,<
    private Button btU, btD;  // +,-
    private Button btFFT;
    private Button btWave;
    private Button btColor;
    private Choice chFile;
    private Choice chSmpl;
    private Scrollbar scrWide;
    private Scrollbar scrV;   // ver.
    private Scrollbar scrH;   // hor.
    private TextField tfA;    //
    private Canvas can;
    private Panel PE, PN, PS, PW;

    public void init() {
	String fnt = getParameter("font");
	FNT = (fnt != null) ? Integer.parseInt(fnt) : 12; //
	Fns = new Font("SansSerif", Font.PLAIN, FNT);
	setFont(Fns);
	fm = getFontMetrics(Fns);
	Fnt = new Font("SansSerif", Font.PLAIN, FNT); // -2

	setBackground(Color.lightGray);
	setLayout(new BorderLayout());
	df1 = new DecimalFormat("#0.0#");
	df2 = new DecimalFormat("#0.00#");  // for mouse P
	
	PE = new Panel();
	PE.setLayout(new GridLayout(5,1,0,0));
	add(PE, "East");

	btU = new Button("+");
	PE.add(btU);
	btU.addActionListener(this);

	btD = new Button("-");
	PE.add(btD);
	btD.addActionListener(this);

	PE.add(new Label());

	btP = new Button(">");
	PE.add(btP);
	btP.addActionListener(this);

	btM = new Button("<");
	PE.add(btM);
	btM.addActionListener(this);
	//--------------------------PE/PN

	PN = new Panel();
	PN.setLayout(new FlowLayout());
	add(PN, "North");

	tfA = new TextField(30);
	tfA.setForeground(Color.blue);
	tfA.setFont(new Font("MonoSpaced", Font.PLAIN, FNT));
	tfA.setEditable(false);
	PN.add(tfA);

	String fn = getParameter("all_f");
	AF = (fn == null) ? 0 : Integer.parseInt(fn);
	if (AF == 0)
	    Error = "No wave file.";
	filenm = new String[AF];  // max files	
	Dirnm = getParameter("dirnm");
	Dirnm = (Dirnm == null) ? "" : Dirnm;
	chFile = new Choice();
	for (int i = 0; i < AF; i++) {
	    filenm[i] = getParameter("wave"+i);
	    chFile.addItem(filenm[i]);
	}
	PN.add(chFile);
        chFile.addItemListener(this);

	chSmpl = new Choice();
	for (int i = 0; i < sample.length; i++)
	    chSmpl.addItem(sample[i]);
	PN.add(chSmpl);
	chSmpl.addItemListener(this);
	Num = 11;
	//-----------------PN/PS

	PS = new Panel();
	PS.setLayout(new GridLayout(2,1,0,0));
	add(PS, "South");

	scrWide = new Scrollbar(Scrollbar.HORIZONTAL,0,0,0,0);
	PS.add(scrWide);
	scrWide.addAdjustmentListener(this);
	
	Panel sm = new Panel();
	sm.setLayout(new GridLayout(1,2,0,0));
	PS.add(sm);
	
	scrH = new Scrollbar(Scrollbar.HORIZONTAL,Hori,1,-90,91);
	scrH.setBlockIncrement(10);
	sm.add(scrH);
	scrH.addAdjustmentListener(this);

	scrV = new Scrollbar(Scrollbar.HORIZONTAL,Vert,1,0,101);
	scrV.setBlockIncrement(10);
	sm.add(scrV);
	scrV.addAdjustmentListener(this);
	//--- PW

	PW = new Panel();
	PW.setLayout(new GridLayout(5,1,0,0));
	add(PW, "West");

	btWave = new Button("Wave");
	PW.add(btWave);
	btWave.addActionListener(this);

	btFFT = new Button("FFT_");
	PW.add(btFFT);
	btFFT.addActionListener(this);

	btColor = new Button("Color");
	PW.add(btColor);
	btColor.addActionListener(this);

	btZin = new Button("><");
	PW.add(btZin);
	btZin.addActionListener(this);

	btZout = new Button("<>");
	PW.add(btZout);
	btZout.addActionListener(this);
	//---------------------------

	can = new MyCanvas();
        add(can, "Center");

	can.addMouseListener(this);
	can.addMouseMotionListener(this);

	init_start();
    }
    public void start() {
	W = getCanvasD().width;
	H = getCanvasD().height;
	BaseLine = H-H/10;
	H2 = BaseLine/2;  // height center

	can.setSize(W, H);
	ig = createImage(W, H);
        gi = ig.getGraphics();
	gi.setFont(Fnt);

	Whby = H2/SMaxVal/Sqrt2;
	Fhby = 0.00002;
    }

    public Dimension getCanvasD() {
	Dimension de = PE.getSize();
	Dimension dn = PN.getSize();
	Dimension ds = PS.getSize();
	Dimension dw = PW.getSize();
	Dimension da = getSize();
	int cw = da.width-(de.width+dw.width);
	int ch = da.height-(dn.height+ds.height);
	Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void init_start() {
	Grap = WAVE;
	set_spl();
	enable_set();
	chSmpl.select(""+Num);
	set_color();

	if (isFile())
	    select_file();
    }
    public boolean isFile() {
	return (AF > 0);
    }
    public void select_file() {
        file_read(chFile.getSelectedItem());
    }
    public void file_read(String fname) {
	setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR)); // 
	read_data(Dirnm+fname);
	setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));

	Wid = Cnt;
	set_smpl();
	Psi = Slc = 0;

	set_Scroll();
    }
    public void set_smpl() {
	set_spl();
	while (Cnt < SPL) {
	    Num--;
	    set_spl();
	    chSmpl.select(""+Num);
	}
    }
    public void set_Scroll() {
	if (Psi+Wid > Cnt) 
	    Psi = Cnt-Wid;

	scrWide.setValues(Psi, Wid, 0, Cnt);
	scrWide.setBlockIncrement(Wid);
    }
    public void mousePressed(MouseEvent e) {
	switch (Grap) {
	case WAVE:
	    lastx = firstx = e.getX();
	    DragSW = true;
	    break;
	}
	can.repaint();
    }
    public void mouseReleased(MouseEvent e) {
	switch (Grap) {
	case WAVE:
	    lastx = e.getX();
	    DragSW = false;

	    selected();
	    break;
	}
	can.repaint();
    }
    public void mouseMoved(MouseEvent me) { 
	switch (Grap) {
	case WAVE:
	    if (MoveSW) {
		Slc = (int)(me.getX()/WD);
		write_tfa();
	    }
	    break;
	}
    }
    public void mouseEntered(MouseEvent e) { 
	TextSW = true;
	write_tfa();
    }
    public void mouseExited (MouseEvent e) {
	TextSW = false;
	write_tfa();
    }
    public void mouseClicked(MouseEvent e) { 
	MoveSW = !MoveSW;
    }
    public void mouseDragged(MouseEvent me) {
	switch (Grap) {
	case WAVE:
	    DragSW = true;
	    lastx = me.getX();
	    break;
	case FFT_:
	    set_scroll_value(me.getX(), me.getY());
	    break;
	}
	can.repaint();
    }
    public void set_scroll_value(int x, int y) {
	if (y < 0)
	    y = 0;
	if (y > H)
	    y = H;
	Vert = (int)(100.0*y/H);
	scrV.setValue(Vert);

	if (x < 0)
	    x = 0;
	if (x > W)
	    x = W;
	Hori = (int)(90-180.0*x/W);
	scrH.setValue(Hori);
    }
    public void itemStateChanged(ItemEvent e) {
        if (e.getSource() == chFile)
	    select_file();

	if (e.getSource() == chSmpl) {
	    Num = Integer.parseInt(chSmpl.getSelectedItem());
	    set_smpl();
	}

	can.repaint();
    }

    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == btZin)       // zoom in
	    wid_ck(false);
	else if (e.getSource() == btZout) // zoom out
	    wid_ck(true);

	else if (e.getSource() == btP) // >
	    pm_redisp(true);
	else if (e.getSource() == btM) // <
	    pm_redisp(false);

	else if (e.getSource() == btU) // +
	    ud_redisp(true);
	else if (e.getSource() == btD) // -
	    ud_redisp(false);

	else if (e.getSource() == btWave) {
	    Grap = WAVE;
	    set_wave_button();
	}	
	else if (e.getSource() == btFFT) {
	    Grap = FFT_;
	    set_fft_button();
	}
	else if (e.getSource() == btColor)
	    set_fft_color();

	enable_set();
	can.repaint();	
	write_tfa();
    }
    public void set_fft_color() {
	FftColor = !FftColor;
	btColor.setLabel(FftColor == true ? "Green" : "Color");
    }
    public void set_wave_button() {
        WaveCnt++;
        if (WaveCnt > 1) {
            WaveSW = !WaveSW;
            WaveCnt = 0;
        }
        resetFFT_button();
    }
    public void set_fft_button() {
        FftCnt++;
        if (FftCnt > 1) {
            FftSW = !FftSW;
            FftCnt = 0;
        }
	resetWave_button();
    }
    public void resetWave_button() {
	WaveCnt = 0;
    }
    public void resetFFT_button() {
        FftCnt = 0;
    }
    public void enable_set() {
	boolean ds = (Grap == WAVE);
	scrV.setEnabled(!ds);
	scrH.setEnabled(!ds);
	chSmpl.setEnabled(!ds);
    }
    public void pm_redisp(boolean sw) {
	switch (Grap) {
	case WAVE:
	    H2 = sw ? H2-H/10 : H2+H/10;
	    break;
	case FFT_:
	    Wby = sw ? Wby/2 : Wby*2;
 	    if (Wby < 2)
		Wby = 2;
	    break;
	}
    }
    
    public void set_spl() {
	SPL = (int)Math.pow(2, Num);
	SPH = SPL/2;
	LPS = 1.0/SPL;
	fftN = new FFT(SPL);

	re = new double[SPL];  // max 14^2
	im = new double[SPL];
	dt = new double[SPH];
	init_gauss();
    }
    
    public void ud_redisp(boolean sw) {
	switch (Grap) {
	case WAVE:
	    Whby = sw ? Whby*Sqrt2 : Whby/Sqrt2;
	    break;
	case FFT_:
	    Fhby = sw ? Fhby*Sqrt2 : Fhby/Sqrt2;
	    break;
	}
    }

    public void wid_ck(boolean sw) {
	int min = SPL;//2;
	Wid = sw ? Wid*2 : Wid/2;

	if (Cnt > 0) {
	    if (Wid > Cnt)
		Wid = Cnt;
	    else if (Wid < min) 
		Wid = min;
	}

	set_Scroll();
    }

    public void selected() {
	if (firstx < 0)
	    firstx = 0;
	if (firstx > W)
	    firstx = W;
	if (lastx < 0)
	    lastx = 0;
	if (lastx > W)
	    lastx = W;

	int wid = (int)(Math.abs(lastx-firstx)/WD);
	if (wid > 1) {
	    Wid = wid;
	    if (lastx < firstx) {
		int x = lastx;
		lastx = firstx;
		firstx = x;
	    }
	    Psi += (int)(firstx/WD);
	    set_Scroll();
	}
    }

    public void adjustmentValueChanged(AdjustmentEvent e) {
	if (e.getSource() == scrWide)
	    Psi = scrWide.getValue();

	if (e.getSource() == scrV) // vert.
	    Vert = scrV.getValue();

	if (e.getSource() == scrH) // hori.
	    Hori = scrH.getValue();

	can.repaint();
    }

    public void write_tfa() {
	if (!isFile()) {
	    tfA.setText(Error);
	    return;
	}
	StringBuffer sb = new StringBuffer(64);

	if (TextSW) {
	    sb.append(Splngf+"[Hz]: ");
	    sb.append(Cnt+": ");
	    sb.append(Label);
	} else {
	    sb.append("<"+dform1(100.0*Wid/Cnt));
	    sb.append("%> "+dform1(Cnt/(double)Splngf));
	    sb.append("[sec]:");
	}

	tfA.setText(Error.equals("") ? sb.toString() : Error);
    }
    public String dform1(double dt) {
	return df1.format((float)dt);
    }
    public String dform2(double dt) {
	return df2.format((float)dt);
    }
    //-----

    class MyCanvas extends Canvas {
	public void update(Graphics g) {
	    can.paint(g);
	}
	public void paint(Graphics g) {
            paintI();
            g.drawImage(ig, 0, 0, this);
        }
    }
    public void set_color() {
        int f = 240, z = 255-f;
        AllC = f*5;
        Gc = new Color[AllC+1];
        for (int i = 0; i < f; i++) {
            Gc[i] = new Color(f, i, z);
            Gc[i+f] = new Color(f-i, f, z);
            Gc[i+f*2] = new Color(z, f, i);
            Gc[i+f*3] = new Color(z, f-i, f);
            Gc[i+f*4] = new Color(i, z, f);
        }
        Gc[AllC] = new Color(f, z, f);
    }
    public void paintI() {
	gi.setColor(Color.black);
	gi.fillRect(0, 0, W, H);

	Font f = getFont();
	Smax = Splngf/Wby;
	Wmax = SPL/Wby;
	SD = W/(double)Smax;
	WD = W/(double)Wid;

	switch (Grap) {
	case WAVE:
	    disp_wave(gi);
	    break;
	case FFT_:
	    disp_fft(gi);
	    break;
	}

	//showStatus(" Vert:"+Vert+" Hori:"+Hori);
    }
    public void disp_wave(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(0, H2, W, H2);             // center line
	g.drawLine(0, BaseLine, W, BaseLine); // base line 

	int val, max = Integer.MIN_VALUE, min = Integer.MAX_VALUE;
	int x, y;
	g.setColor(Color.green);
	for (int i = 0; i < Wid; i++) {
	    val = dat[Psi+i];
	    x = (int)(WD*i);
	    y = (int)(H2-Whby*val);
	    g.drawLine(x, y, x, y); // dot
	    max = Math.max(max, val);
            min = Math.min(min, val);
	}

	disp_time(g);
	if (!WaveSW)
	    disp_wave_value(g, min, max);
	if (DragSW)
	    disp_cursor(g);
    }
    public void disp_cursor(Graphics g) {
	if (firstx < 0)
	    firstx = 0;
	if (firstx > W)
	    firstx = W-1;
	if (lastx < 0)
	    lastx = 0;
	if (lastx > W)
	    lastx = W-1;

	g.setColor(bar);
	g.drawLine(firstx, 0, firstx, H);
	g.drawLine(lastx, 0, lastx, H);
    }
    public void disp_time(Graphics g) {
        double tim, allsec = Wid/(double)Splngf;

        if (allsec < 0.1)
            tim = 0.01;
        else if (allsec < 0.3)
            tim = 0.05;
        else if (allsec < 1)
            tim = 0.1;
        else if (allsec < 3)
            tim = 0.5;
        else if (allsec < 10)
            tim = 1;
        else if (allsec < 30)
            tim = 5;
        else if (allsec < 60)
            tim = 10;
        else
            tim = 60;

        String s = "[sec] ";
        g.setColor(Color.yellow);
        g.drawString(s, W-fm.stringWidth(s), H-1);

        double asec = tim/(allsec/W);
        int maxsec = (int)(allsec/tim);
        if (maxsec > 0) {
            int ss = H-FNT;  // ʸh
            int x, l = 5;
            for (int i = 0; i <= maxsec; i++) {
                x = (int)(asec*i);

                g.setColor(Color.gray);
                g.drawLine(x, BaseLine, x, BaseLine+l);

                g.setColor(Color.yellow);
                g.drawString(dform1(i*tim), x, ss);
            }
        }
    }
    public void disp_wave_value(Graphics g, int min, int max) {
        g.setColor(Color.lightGray);
	g.drawString(dform1(100*max/SMaxVal), 1, (int)(H2-max*Whby));
	g.drawString(dform1(100*min/SMaxVal), 1, (int)(H2-min*Whby+FNT));
	g.drawString("[%]", 1, FNT);
    }

    public void disp_memori(Graphics g, int loop, double sf, double ver) {
	double sdi;
	double dsf = (sf > 0) ? sf : 0;  // down shift
	double usf = (sf > 0) ? 0 : -sf; // up shift
	int ve = (int)ver;

	g.setColor(Color.gray);        // h line
	g.drawLine((int)usf, ve, W, ve);
	g.drawLine((int)dsf, BaseLine, W, BaseLine);

	for (int i = 0; i < Smax; i += 10) { // disp. memori
	    if (i % 1000 == 0){
		g.setColor(Color.orange);
		g.drawString(i/1000+"k", (int)(SD*i+dsf), BaseLine+FNT);
		
		g.setColor(Color.white);
	    } else if (i % 500 == 0)
		g.setColor(Color.lightGray);
	    else if (i % 100 == 0 && Smax < 5000)
		g.setColor(Color.gray);
	    else if (Smax < 800)
		g.setColor(Color.darkGray);
	    else
		continue;

	    sdi = SD*i;
	    g.drawLine((int)(sdi+usf), ve, (int)(sdi+dsf), BaseLine);
	}

	String s = "[Hz] ";
	g.setColor(Color.orange);
        g.drawString(s, W-fm.stringWidth(s), H-1);
    }
    public void calc_fft(int loop) {
	for (int i = 0; i < SPL; i++) {   
	    re[i] = dat[Psi+i+loop*SPL];
	    im[i] = 0;
	}

	gauss();  // window
	fft();
    }
    public void disp_fft(Graphics g) {
	double wd = W/(double)Wmax;
	double hh, x0, y0, x1, y1, xsf;
	int loop = Wid/SPL;
	double sf = W*Hori/100.0;
	double wsf = sf/loop;
	double ver = (int)(BaseLine*Vert/100.0);
	disp_memori(gi, loop, sf, ver);
	double dc = AllC/(double)loop;

	if (FftColor)
	    g.setColor(Color.green);
	for (int j = 0; j < loop; j++) {
	    calc_fft(j);

	    hh = ver+j*(BaseLine-ver)/(double)loop;
	    xsf = (wsf > 0) ? wsf*j : -wsf*(loop-j);
	    x0 = y0 = 0;
	    if (!FftColor)
		g.setColor(Gc[(int)(j*dc)]);
	    for (int i = 0; i < Wmax; i++) {
		x1 = i*wd+xsf;
		y1 = dt[i]*Fhby;
		if (i == 0) {
		    x0 = x1;
		    y0 = y1;
		}
		if (FftSW)
		    g.drawRect((int)x0, (int)(hh-y1), (int)wd, (int)y1);
		else		
		    g.drawLine((int)x0, (int)(hh-y0), (int)x1, (int)(hh-y1));
		x0 = x1;
		y0 = y1;
	    }
	}
    }
    //-----
    
    public void init_gauss() {
	Gauss = new double[SPL];
	double is;
        for (int i = 0; i < SPL; i++) {
	    is = (2.0*i-SPL)*LPS;
	    Gauss[i] = Math.exp(-4.5*is*is);
	}
    }
    public void gauss() {              // window
        for (int i = 0; i < SPL; i++) {
	    re[i] *= Gauss[i];
	    im[i] = 0;
	}
    }
    public void fft() {
	fftN.fft(re, im);

	for (int i = 0; i < SPH; i++)
	    dt[i] = Math.sqrt(re[i]*re[i]+im[i]*im[i]);
    }

    public void read_data(String fname) {
	try {
            URL url = new URL(getDocumentBase(), fname);
            ReadWave rw = new ReadWave(url);

            dat = rw.getData();
	    Splngf = rw.getSamplf();
	    Cnt = rw.getCount();
	    Label = rw.getLabel();
            Error = rw.getError();
	} catch(Exception e) {
            Error = "File read error.";
        }
    }
}